"""
	MODULE enigma

	DESCRIPTION Classe che simula il comportamento di una macchina Enigma
	con solo i tre rotori.

	@copyright: 2015 by Alessandro Bugatti <alessandro.bugatti@gmail.doc>
	@license: GNU GPL, see COPYING for details.
"""

class Enigma:

    def __init__ (self):
        self.rotori = list()
        
    def addRotore(self, rotore):
        self.rotori.append(rotore)
        
    def inizialize(self, configuration):
        rotore = 0
        for position in configuration:
            for i in range((int(position) - self.rotori[rotore].giro)%26):
                self.rotori[rotore].tick()
                self.rotori[rotore].complete_turn()
            rotore = rotore + 1
           
    def letterEncryption(self, letter):
        #Trasformo la lettera in un numero
        n = ord(letter) - ord('A') + 1
        #passaggio in 'avanti' della lettera
        for rot in self.rotori:
            n = rot.in_front(n);
        #riflessione, semplicemente assume il valore simmetrico rispetto 
        #al centro dei valori (ad. esempio se 1 diventa 26, se 4 diventa
        #22
        n = 26 - n + 1
        #passaggio 'indietro' della lettera
        for rot in reversed(self.rotori):
            n = rot.from_back(n);
        #ritrasformo il numero in lettera
        return chr(n - 1 + ord('A'))
    
    def encrypt(self, message):
        cypher = ''
        for letter in message:
            cypher += self.letterEncryption(letter)
            self.tick()
        return cypher
        
    def tick(self):
        self.rotori[0].tick()
        for i in range(len(self.rotori)):
            if i != len(self.rotori) - 1 and self.rotori[i].complete_turn() == True:
                self.rotori[i+1].tick()
            
